#ifndef _CONFIG_H_
#define _CONFIG_H_

#include "Util.h"

class Config{
public:
	bool ALLOWGU    ;//1
	int MINSTACKLEN ;//4
	int MINLOOPLEN  ;//3
	int MINHYDROGEN ;//8
	int MAXSEQLEN   ;//1000
	int MAXMATRIXSZ ;//2000
	double BARRIERCUTOFF;//12
	double BARRIERCUTOFFDELTA; //1
	int MAXOVERLAP;//2
//	double MAXINWARDOVERLAP_PERCENT;//0.2
//	int MAXPARALLELOVERLAP;//2
	double BSTAR;
	double VAR1;
	double VAR2;
	double P_MAXGAP; //0.6, columns with more than P_MINGAP gaps will be removed from the MSA
	Config () {
		ALLOWGU = true;
		MINSTACKLEN = 4; /* minimum stack length */
		MINLOOPLEN  = 3; /* minimum number nt in a loop; unpaired bases between any pairing bases */
		MINHYDROGEN = 8;
		MAXSEQLEN = 1000;
//		MAXINWARDOVERLAP_PERCENT = 0.20;
//		MAXPARALLELOVERLAP = 2;
		MAXOVERLAP = 2;
		BSTAR = -2; //default -2
		VAR1 = 1.0;
		VAR2 = 1.0; //none complementary factor
		P_MAXGAP = 0.6;//0.6, columns with more than P_MINGAP gaps will be removed from the MSA
		MAXMATRIXSZ  =2000;
		BARRIERCUTOFF = 12;
		BARRIERCUTOFFDELTA = 1;
	}
	Config(const string & configfile) { setConfig(configfile);}
	void setConfig(const string & configfile);
	string trim(const string & in_s);
	void show(ostream & fout=cout);
	void increaseBARRIERCUTOFF();
	void resetBARRIERCUTOFF(const int&);
};
#endif 
