#include "neighborjoin.h"
/*******************************************************************************
                             mytable
*******************************************************************************/
mytable::mytable(vector<vector<double> > & in_D) {
	original_num = valid_num = sz(in_D);
	int n = sz(in_D);
	D = in_D;
	FOR(i,0,n) {
		assert(sz(in_D[i]) == i);
	}
	
	FOR(i,0,n) {
		valid.PB(true);
		tree.PB(TNode());
	}
}

void mytable::pickminD(int & indx_i, int & indx_j) 
{	//Pick a pair i,j for which Q[i][j] is the smallest among all the cells that are valid.
	int n = sz(D);
	double minval = 0;
	indx_i = indx_j = -1;
	bool start = false;
	FOR(i,0,n) {
		if(!valid[i]) continue;
		FOR(j,0,i) {
			if(!valid[j]) continue;
			if(!start) {
				start = true;
				minval = D[i][j];
				indx_i = i;
				indx_j = j;
			} else {
				if(minval > D[i][j]) {
					minval = D[i][j];
					indx_i = i;
					indx_j = j;
				}
			}
		}
	}
	if(!start) {
		cerr<<"The overall matrix has been processed."<<endl;
		exit(0);
	}
}


//join neighbors according to the distance between structures.
vector<int> mytable::DJ(const int & knum, const vector<RNA> & vrna, ofstream & fout, vector<int> & vorder) {
	int delta = 0; 
	int n = original_num;
	vorder.clear();
	if(n==1) {
		vorder.PB(0);
	}
	while(n>1) {
		int indx_i = -1;
		int indx_j = -1; 
		pickminD(indx_i, indx_j);
		assert(indx_i>indx_j);
		
		int indx_rm = -1;
		if(vrna[indx_i].e < vrna[indx_j].e) {
			tree[indx_j].pt = indx_i;
			valid[indx_j] = false;
			indx_rm = indx_j;
		} else {
			tree[indx_i].pt = indx_j;
			valid[indx_i] = false;
			indx_rm = indx_i;
		}
		vorder.PB(indx_rm);
		if(n==2) {
			vorder.PB(0);
		}
		n--;
	}

	vector<int> ret;
	FOR(k,0,min(knum, sz(vorder))) {
		ret.PB(vorder[sz(vorder)-1-k]);
	}

	return ret;
} 
	

void mytable::show() {
	cout<<"The original num is "<<original_num<<endl;
	cout<<"The valid num is "<<valid_num<<endl;
	//print out D
	cout<<"D"<<endl;
	FOR(i,0,sz(D)) {
		cout<<setw(6)<<i<<" ";
		FOR(j,0,sz(D[i])) {
			cout.precision(2);
			cout<<setw(6)<<D[i][j]<<" ";
		}
		cout<<endl;
	}
	cout<<endl;


	cout<<"valid"<<endl;
	//print out valid
	FOR(i,0,sz(valid)) {
		cout<<"["<<i<<"] = ";
		if(valid[i]) 
			cout<<"T"<<endl;
		else 
			cout<<"F"<<endl;
	} 
	cout<<endl;
	//print out tree
	cout<<"Tree"<<endl;
	showtree(sz(tree)-1, 0);
	cout<<endl;	
}

void mytable::showtree(const int & n, const int & indent) {

}

